<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { storeToRefs } from 'pinia';
import { useI18n } from 'vue-i18n';
import { ref, inject } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import DropdownItem from '@/components/general/DropdownMenuEntry.vue';
import { useAccountStore } from '@/stores/account';
import { deleteCookie } from '@/lib/utils';
import PasswordResetModal from '@/components/account/PasswordResetModal.vue';
import AccountDeleteModal from '@/components/account/AccountDeleteModal.vue';
import AccesscodeModal from '@/components/account/AccesscodeModal.vue';
import { request } from '@/lib/request';
import Dropdown from '@/components/general/Dropdown.vue';

const { t } = useI18n();
const $t = t;

const route = useRoute();
const router = useRouter();
const store = useAccountStore();
const { mail } = storeToRefs(store);

let configuration = inject<any>('configuration');

const logout = async (close: () => void) => {
    let result = await request('DELETE', configuration.apiServer + '/api/account/logout', undefined, 'application/json', false, true);
    if (result && result.success) {
        deleteCookie('Token', configuration.basePath);
        mail.value = '';
        localStorage.setItem('logout-event', 'logout' + Math.random());
        router.push({ name: "home" });
    }
    close();
}

const handlePasswordReset = (close: () => void) => {
    showPasswordResetModal(true);
    close();
}

const isPasswordResetModalOpen = ref(false);
const showPasswordResetModal = (value: boolean) => {
    isPasswordResetModalOpen.value = value;
}

const handleClosePasswordResetModal = () => {
    showPasswordResetModal(false);
}

const handleAccountDelete = (close: () => void) => {
    showAccountDeleteModal(true);
    close();
}

const isAccountDeleteModalOpen = ref(false);
const showAccountDeleteModal = (value: boolean) => {
    isAccountDeleteModalOpen.value = value;
}

const handleCloseAccountDeleteModal = () => {
    showAccountDeleteModal(false);
}

const logoutAfterDelete = () => {
    deleteCookie('Token', configuration.basePath);
    mail.value = '';
    localStorage.setItem('logout-event', 'logout' + Math.random());
    router.push({ name: "home" });
}

const isAccesscodeModalOpen = ref(false);
const showAccesscodeModal = (value: boolean) => {
    isAccesscodeModalOpen.value = value;
}
const handleShowAccesscodeModal = (close: () => void) => {
    showAccesscodeModal(true);
    close();
}

const handleCloseAccesscodeModal = () => {
    showAccesscodeModal(false);
}


</script>
<template>
    <Dropdown>
        <template v-slot:button="{ open }">
            <button class="cursor-pointer lowercase text-white border-b-1 border border-x-0 border-t-0 border-white h-8 leading-8 align-middle flex">
                <i class="ri-user-line"></i>
                <span class="hidden lg:block">{{ mail }}</span>
                <i :class="[{ 'ri-arrow-up-s-line': open }, { 'ri-arrow-down-s-line': !open }]"></i>
            </button>
        </template>
        <template v-slot="{ close }">
            <DropdownItem @click="handlePasswordReset(close)" icon="key"
                :label="$t('general.variables.password.sg') + ' ' + $t('general.variables.change')"
                color="text-emerald-500" v-if="String(route.path).includes('overview')" />
            <DropdownItem @click="handleShowAccesscodeModal(close)" icon="pencil" color="text-blue-600"
                :label="$t('general.variables.account.sg') + ' ' + $t('general.variables.change')"
                v-if="String(route.path).includes('overview')" />
            <DropdownItem @click="handleAccountDelete(close)" icon="delete-bin" color="text-red-700"
                :label="$t('general.variables.account.sg') + ' ' + $t('general.variables.delete')"
                v-if="String(route.path).includes('overview')" />
            <DropdownItem @click="logout(close)" icon="logout-circle-r" :label="$t('general.variables.account.logout')"
                color="text-orange-500" />
        </template>
    </Dropdown>
    <PasswordResetModal v-if="isPasswordResetModalOpen" @close="handleClosePasswordResetModal" />
    <AccountDeleteModal v-if="isAccountDeleteModalOpen" @close="handleCloseAccountDeleteModal"
        @success="logoutAfterDelete" />
    <AccesscodeModal v-if="isAccesscodeModalOpen" @close="handleCloseAccesscodeModal" />
</template>
